<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <button (click)="newRow(modalHelp)" class="btn btn-primary py-2 px-4">
        <i class="fa fa-plus mr-2"></i>Nueva Mesa
    </button>
    <!-- <button (click)="flagMapaMesas = false;" class="btn btn-warning py-2 px-4 ml-1" *ngIf="flagMapaMesas">
        <i class="fa fa-table mr-2"></i>Grid Mesas
    </button> -->
    <!-- <button (click)="printPDF()" class="btn btn-light ml-1" [disabled]="!dataGrid">
        <i class="fas fa-file-pdf text-danger mr-2"></i>PDF
    </button> -->
    <button (click)="btnMapaMesas();" class="btn btn-info py-2 px-4 ml-1">
        <i class="fa fa-th-large mr-2"></i>Mapa Mesas
    </button>
</app-page-title>

<div class="animated fadeIn">
    <kendo-grid [kendoGridBinding]="dataGrid" [filter]="filter" [filterable]="false" [selectable]="true"
        [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort" [sortable]="true" [groupable]="true"
        [group]="groups" (detailExpand)="detailExpand($event)" (edit)="editGridRow($event, modalHelp)"
        (remove)="deleteGridRow($event)" [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" [skip]="0"
        [pageSize]="10" style="height: 76vh" *ngIf="!loading">
        <ng-template kendoGridDetailTemplate let-dataItem>
            <app-mesa-turnos [data]="dataExand"></app-mesa-turnos>
        </ng-template>
        <kendo-grid-column field="Punto" title="Punto" width="200"></kendo-grid-column>
        <kendo-grid-column field="cMesa" title="Mesa" width="200"></kendo-grid-column>
        <kendo-grid-column field="cMdesc" title="Ubicación"></kendo-grid-column>
        <kendo-grid-column field="iMcap" title="Capacidad" width="130" [filterable]="false"></kendo-grid-column>
        <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
            <ng-template kendoGridCellTemplate let-dataItem>
                <input type="checkbox" [checked]="dataItem.Inactivo" disabled />
            </ng-template>
        </kendo-grid-column>
        <kendo-grid-command-column title="Actions" width="190">
            <ng-template kendoGridCellTemplate let-isNew="isNew">
                <button kendoGridEditCommand [primary]="true">Editar</button>
                <button kendoGridRemoveCommand>Eliminar</button>
            </ng-template>
        </kendo-grid-command-column>
    </kendo-grid>

    <app-loading *ngIf="loading"></app-loading>

</div>


<ng-template #modalMapa let-c="close" let-d="dismiss" class="p-2">
    <div class="animated fadeIn" style="background: #3d4959;color: white;">

        <div class="row mx-1">
            <div class="form-group col-3">
                <label for="Punto">Punto</label>
                <kendo-combobox [data]="dsPuntos" [(ngModel)]="puntoSelected" (valueChange)="buscarPlano();"
                    [textField]="'pdesc'" [valueField]="'Punto'" name="Punto" class="w-100">
                </kendo-combobox>
            </div>
            <div class="form-group col-2">
                <label for="planoBg">Img. Fondo</label>
                <input type="text" class="form-control" [(ngModel)]="planoBg" (change)="changeTemplate();">
            </div>
            <div class="form-group col-1">
                <label for="planoX">Ancho (px)</label>
                <input type="number" class="form-control" [(ngModel)]="planoX" (change)="changeTemplate();">
            </div>
            <div class="form-group col-1">
                <label for="planoY">Alto (px)</label>
                <input type="number" class="form-control" [(ngModel)]="planoY" (change)="changeTemplate();">
            </div>
            <div class="form-group">
                <label for="switchInactivo" class="w-100">Inactivos</label>
                <kendo-switch name="switchInactivo" [(ngModel)]="switchInactivo" (valueChange)="buscarPlano();"
                    [onLabel]="'Si'" [offLabel]="'No'">
                </kendo-switch>
            </div>
            <div class="col d-flex justify-content-end mt-1 p-2">
                <button class="btn btn-light ml-1" (click)="changeAction('m');"
                    [disabled]="!puntoSelected || !dataPlanoMesas || !flagResizeMesa">
                    <i class="fa fa-arrows-alt mr-2"></i>Mover
                </button>
                <button class="btn btn-light ml-1" (click)="changeAction('r');"
                    [disabled]="!puntoSelected || !dataPlanoMesas || !flagMoverMesa">
                    <i class="fa fa-expand mr-2"></i>Resize
                </button>
                <button (click)="newRow(modalHelp)" class="btn btn-primary ml-1">
                    <i class="fa fa-plus mr-2"></i>Nueva Mesa
                </button>
                <button class="btn btn-danger ml-1" (click)="c(); closeMapa();">
                    <i class="fas fa-window-close mr-2"></i>Cerrar
                </button>
            </div>
        </div>

        <div class="example-boundary m-1" mwlResizable [enableGhostResize]="true"
            [resizeEdges]="{bottom: true, right: true, top: true, left: true}"
            (resizeEnd)="onResizeEndTemplate($event);"
            [ngStyle]="{'width.px': planoX, 'height.px': planoY, 'background': 'url(assets/images/' + planoBg + ')'}"
            style="overflow: auto;">

            <ng-container *ngIf="puntoSelected && flagMoverMesa">
                <div class="example-box" cdkDragBoundary=".example-boundary" cdkDrag
                    *ngFor="let item of dataPlanoMesas;" (dblclick)="editRow(item, modalHelp);"
                    [ngClass]="{ 'bg-danger text-white': item.Inactivo }"
                    [ngStyle]="{'left.px': item.cCoordenada[0], 'top.px': item.cCoordenada[1], 'width.px': item.cCoordenada[2],
                    'height.px': item.cCoordenada[3], 'visibility': !switchInactivo && item.Inactivo ? 'collapse' : 'visible' }" [matTooltip]="item.cMdesc"
                    (cdkDragEnded)="onDragEnded($event, item);">
                    <div>
                        <h6 class="font-weight-bold">{{ item.cMesa }}</h6>
                        <div class="row">
                            <!-- <small class="col">{{ item.cMdesc }}</small> -->
                            <small class="col-12"><i class="fa fa-user mr-1"></i>{{ item.iMcap }}</small>
                        </div>
                    </div>
                </div>
            </ng-container>


            <ng-container *ngIf="puntoSelected && flagResizeMesa">
                <div class="example-box" mwlResizable *ngFor="let item of dataPlanoMesas;" (dblclick)="editRow(item);"
                    [ngStyle]="{'left.px': item.cCoordenada[0], 'top.px': item.cCoordenada[1], 'width.px': item.cCoordenada[2],
                                    'height.px': item.cCoordenada[3], 'visibility': !switchInactivo && item.Inactivo ? 'collapse' : 'visible' }"
                    [enableGhostResize]="true" [resizeEdges]="{bottom: true, right: true, top: true, left: true}"
                    [matTooltip]="item.cMdesc" (resizeEnd)="onResizeEnd($event, item);">
                    <div>
                        <h6 class="font-weight-bold">{{ item.cMesa }}</h6>
                        <!-- <small>{{ item.cMdesc }}</small> -->
                        <div class="row">
                            <small class="col-12"><i class="fa fa-user mr-1"></i>{{ item.iMcap }}</small>
                        </div>
                    </div>
                </div>
            </ng-container>

            <div class="jumbotron text-center" style="background: transparent;" *ngIf="!puntoSelected">
                <h1 class="display-4">Plano de Mesas!</h1>
                <p class="lead">Selecciona un Punto de Venta para visualizar el plano de mesas</p>
                <hr class="my-4">
            </div>
        </div>

    </div>
</ng-template>


<ng-template #modalHelp let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h6 class="modal-title">
            <span *ngIf="!flagEdit">Nueva Mesa</span>
            <span *ngIf="flagEdit">Actualizar Mesa</span>
        </h6>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <form [formGroup]="myFormGroup">
            <div class="row-fluid animated fadeIn">
                <fieldset>
                    <div class="row">
                        <label class="form-group col-12">
                            <label>Punto</label>
                            <kendo-combobox [data]="dsPuntos" [valuePrimitive]="true" [textField]="'pdesc'"
                                [valueField]="'Punto'" formControlName="Punto" class="w-100" [readonly]="flagEdit">
                            </kendo-combobox>
                        </label>
                    </div>
                    <div class="row">
                        <div class="form-group col-4">
                            <label>Mesa</label>
                            <input class="form-control" formControlName="cMesa" [readOnly]="flagEdit">
                        </div>
                        <div class="form-group col-8">
                            <label>Ubicación</label>
                            <input class="form-control" formControlName="cMdesc">
                        </div>
                    </div>
                    <div class="row">
                        <div class="form-group col-6">
                            <label>Capacidad</label>
                            <input type="number" class="form-control" formControlName="iMcap">
                        </div>
                        <div class="form-group col-6">
                            <label class="w-100">Inactivo</label>
                            <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
                            </kendo-switch>
                        </div>
                    </div>
                </fieldset>
            </div>
        </form>
    </div>
    <div class="modal-footer">
        <button class="btn btn-success ml-1" [disabled]="myFormGroup.invalid" (click)="guardarForm(); c();">
            <i class="fas fa-save mr-2"></i>Guardar
        </button>
        <button class="btn btn-danger ml-1" (click)="deleteRow(myFormGroup.value); c();"
            *ngIf="flagEdit && flagMapaMesas">
            <i class="fas fa-trash mr-2"></i>Eliminar
        </button>
        <button class="btn btn-shadow btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>